StartFibonacci = () => {
    let x = 0
    let y = 1

    return () => {
        const f = x;
        [x, y] = [x+y, x]
        return f
    }
}

// 1. 10 Elemente der Fibonacci Folge
nextFibonacci = StartFibonacci()
for (let i=0; i<10; i++) console.log(nextFibonacci())


// 2. Closure, die eine Funktion enthält, an die das jeweils nächste Element der Fibonacci-Folge übergeben wird
FibonacciFun = (fun) => {
    const next = StartFibonacci()
    return () => {
        fun(next())
    }
}

// 2.a ... das kann natürlich auch ganz einfach `console.log` sein
nextFibonacciFun = FibonacciFun(console.log)
for (let i =0; i<10; i++) nextFibonacciFun()


// 3. Erzeuge eine Closure, die eine Funktion als Argument bekommt
FibonacciToFunArg = () => {
    const next = StartFibonacci()
    return (funArg) => {
        funArg(next())
    }
}

fibonacciToFun = FibonacciToFunArg()
// 3.a ... das kann dann bei jedem Aufruf eine andere Funktion sein. Hier nur console.log
for (let i=0; i<10; i++) fibonacciToFun(console.log)
